<?

/*    LIMACUTE - Linpro Mailserver Configuration Utility Eh...
 *
 *    Copyright (C) 2000-2001 Linpro AS
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *    Contact: limacute@linpro.no or 
 *    Linpro AS, Waldemar Thranes gate 98 B, 0175 OSLO, Norway
 *    <ULR: http://www.linpro.no/ >
 */

session_start();

//initialize status here, so that we avoid warnings later
// TODO knuthaug 2001-08-30: Make status a function call so that we 
// can format the status differently if its a message or an error.
$status = "";

if($view == "admin"){
    // Change theme if that was our last action
    if($themenr) {
        if (is_writable("theme") && preg_match("/^([0-9]){2}$/", $themenr)){
            $fp = fopen("theme","w") or $na=TRUE;
            if($na){
                $status = "Error writing config. (1)";
            } else {
                fwrite($fp, $themenr);
                fclose($fp);
                $status = "Theme changed.";
            }
        }
        else {
            $status = "Error writing config. (2)";
        }
    }
}


include_once ("config.inc.php");
include_once ("functions.php");

// Sjekker for NULL-password.
if ( (isset($bindpw) && ($bindpw)) || $inside){
    
    if($view == "admin"){
        $binddn = $master;
    }
    elseif($view == "domain"){
        $binddn="domain=$domain,ou=Domains,$basedn";
    }
    elseif($view == "user"){
        $binddn="uid=$username,ou=People,domain=$domain,ou=Domains,$basedn";
    }
    else{
        unset($inside);
        //session_unset("inside");
        include ("$include/header.htm");
        include ("$include/top.htm");
        echo ("<h1>Error: Wrong view.</h1>");
        include ("$include/footer.htm");
        exit;
    }


    // If it's the first time the user logs in.
    // Store the password in a cookie.
    if ( !($inside)){
        session_register("login");
        
        //base64 encoded onetimepad, the same length as the password
        // is stored in the session, XORED with the password
        $onetimepad = makeRandomString(strlen($bindpwd));
        $key = OneTimePadEncrypt ($bindpw, $onetimepad);
        session_register ("onetimepad");
        
        $int2 = setcookie("key", $key, 0);
        $inside="1";

    } 
    else { 
        if ( isset($HTTP_COOKIE_VARS["key"])){
            $key = $HTTP_COOKIE_VARS["key"];                        
        }
    }

    // schmack them back together again
    $bindpw = OneTimePadDecrypt ($key, $onetimepad);

    // Delay the output
    ob_start();
    // ------------------Start htmloutput -----

    include ("$include/header.htm");
    //Debug....
    if ($debug) {
        //  $bindpw = "test";
        echo "\n<br>Binddn: " . $binddn;
        echo "\n<br>View: " . $view;
        echo "\n<br>key1: " . $key1;
        echo "\n<br>xxxxKey2: " . $key2;
        echo "\n<br>bindpw: " . $bindpw;
        echo "\n<br>domain: " . $domain;
        echo "\n<br>inside: " . $inside;
        echo "\n<br>flik: " . $flik;    
        echo "\n<br>update:" . $update;
        if ($view=="user")
            echo "\n<br>Username: " . $username;
        echo "\n<br>";
    }
    // end debug


    $ds=ldap_connect($server);
    if (!$ds){
        unset($inside);
        //session_unset ("inside");
        echo "\n<h4>Unable to connect to LDAP server</h4>";
    } 
    else { 
        if ($ds && $binddn && $bindpw) {
            $r=ldap_bind($ds, $binddn, $bindpw);
            if (!$r){
                unset($inside);
                //session_unset ("inside");
                include ("$include/top.htm");
                echo ("<center><br />"); 
                echo ("<h1>Wrong username or password</h1>");
                echo ("<h2><a href=\"index.php?view=$view\">Try again</a></h2>");
                echo ("</center>");
                
                include ("$include/footer.htm");
                ldap_close($ds);
                exit;
            } 
            else {
                // The main code.
                // Code depends on witch view.
                $fil = "$include/inner_" .$view . "_top.htm";
                include ("$include/top.htm");
                include("$fil");
                include ("$include/inner_footer.htm");
            }
        }
        ldap_close($ds);
    }

} else {

    include ("$include/header.htm");
    include ("$include/top.htm");
    include("$include/$view.inc.php");
}

include ("$include/footer.htm");
ob_end_flush();
?>
